###############################################################################
# RSS_Feed.pl                                                                 #
# Based on Recent.pl #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2 RC 1                                                 #
# Released:       December 27, 2004                                           #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$rss_feedplver = 'YaBB 2 RC 1 $Revision: 1.0 beta 1 $';
if($action eq 'detailedversion') { return 1; }

sub RSS_Feed {

use Time::Local;

## figure out which cats to feed
	@rsscategories = ();
	require "$vardir/rssfeed.txt";
	while ( ( $testcat, $rssvalue ) = each %rsscat ) {
		if ( $rssvalue ne 'rss' ) { delete $rsscat{$testcat}; }
	}
	@rsscategories = keys %rsscat;

	if ( $INFO{'feedcat'} ) {
		@rsscategories = ();
		@rssinfocats = ();
		if ( $INFO{'feedcat'} =~ m~\.~ ) { @rssinfocats = split (/\./,$INFO{'feedcat'}); } else {@rssinfocats[0] = $INFO{'feedcat'};}
		$i=0;
		foreach (@rssinfocats) {
			if ( $rsscat{"$_"} ) {
				$rsscategories[$i] = $_;
				$i++;
			}
		}
	}

## figure out which boards to feed
	@rssboards = ();
	while ( ( $testboard, $rssvalue ) = each %rssboard ) {
		if ( $rssvalue ne 'rss' ) { delete $rssboard{$testboard}; }
	}

	@rssboards = keys %rssboard;

	if ( $INFO{'feedboard'} ) {
		@rssboards = ();
		@rssinfoboards = ();
		if ( $INFO{'feedboard'} =~ m~\.~ ) { @rssinfoboards = split (/\./,$INFO{'feedboard'}); } else {@rssinfoboards[0] = $INFO{'feedboard'};}
		foreach (@rssinfoboards) {
			if ( $rssboard{"$_"} ) {
				$rssboardgood{"$_"} = 'rss';
			}
		}
	}

####################
	my $display = $RSS_Display;
	my( @memset, @categories, %data, $numfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	$numfound=0;

	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	foreach $catid (@rsscategories){$boardlist = $cat{$catid};
# Return no boards or categories if both feedcat and feedboard are used
		if ( $INFO{'feedcat'} && $INFO{'feedboard'} ) {next;}
		
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

		foreach $curboard (@bdlist) {
			($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});


			if ( $INFO{'feedboard'} && !$rssboardgood{"$curboard"} ) {next;}
			if ( !$rssboard{"$curboard"} ) {next;}

			$catname{$curboard} = $catname;

			fopen(REC_BDTXT, "$boardsdir/$curboard.txt");
				for ($i = 0; $i < $display && ($buffer = <REC_BDTXT>); $i++) {
					($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $buffer );
					unless($tstate =~ /h/){
						$mtime = $tdate;
						$data[$numfound] = "$mtime|$curboard|$tnum|$treplies|$tusername|$tname|$tstate";
						$numfound++;
					}
				}
			fclose(REC_BDTXT);
		}
	}

	@data = reverse sort @data;
	$numfound=0;
	for ($i = 0; $i < @data; $i++) {
		($mtime, $curboard, $tnum, $treplies, $tusername, $tname, $tstate) = split( /\|/, $data[$i] );
		unless($tstate =~ /h/){
			$count = 0;
			fopen(REC_THRETXT, "$datadir/$tnum.txt") || next;
			while( <REC_THRETXT> ) { $message = $_; $count++;}
			# get only the last post for this thread.
			fclose(REC_THRETXT);
			chomp $message;

			if( $message ) {
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
				$messages[$numfound] = "$curboard|$tnum|$treplies|$tusername|$tname|$msub|$mname|$memail|$mdate|$musername|$micon|$mattach|$mip|$message|$mns|$tstate";
				$numfound++;
				$count--;
				push (@postposition, $count);
			}
			if ($numfound == $display) {last;}
		}
	}

	if( $numfound>0 ) {
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
	}

##############################

### strip weird characters from boardname and RSS Description
&StripChars($mbname);
&StripChars($RSS_Description);

	$YaBB_RSS = qq~Content-type: application/xml\n
<?xml version="1.0" encoding="iso-8859-1" ?> 
<rss version="2.0" 
    xmlns:dc="http://purl.org/dc/elements/1.1/">
<channel>
  <image> 
    <title>$RSS_Description</title>
    <url>$RSS_Image</url>
    <link>$scripturl</link>  
    <description>$RSS_Description</description>
  </image>
  <title>$mbname</title>
  <description>$RSS_Description</description>
  <link>$scripturl</link>
~;
#######################################
	for( $i = 0; $i < $numfound; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate) = split( /\|/, $messages[$i] );
		$displayname = $mname;

		if( $tusername ne 'Guest' && -e "$memberdir/$tusername.vars" ) {
			&LoadUser($tusername);
			$tname = exists ${$uid.$tusername}{'realname'} ? ${$uid.$tusername}{'realname'} : $tname;
			$tname ||= $txt{'470'};
			$tname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" title="$txt{'27'}: $musername">$tname</a>~;
		}
		if( $musername ne 'Guest' && -e "$memberdir/$musername.vars" ) {
			&LoadUser($musername);
			$mname = exists ${$uid.$musername}{'realname'} ? ${$uid.$musername}{'realname'} : $mname;
			$mname ||= $txt{'470'};
#			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" title="$txt{'27'}: $musername">$mname</a>~;
		}
###

		if ($RSS_Cutoff) {
			if (length($message) > $RSS_Cutoff) { $message = substr($message,0,$RSS_Cutoff); $message .= "...";}
		}

###
		$message = &Censor($message);
		$msub = &Censor($msub);
		&wrap;
		if($enable_ubbc) { $ns = $mns; if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		&ToChars($msub);
		&ToChars($message);
		&ToChars($boardname{$board});



#######################################
### strip weird characters out of all user input fields

		&StripChars($message);
		&StripChars($mname);
		&StripChars($msub);
		&StripChars($boardname{$board});

		($rsssec,$rssmin,$rsshour,$rssday,$rssmonth,$rssyear,$wday,$yday,$dummy) = gmtime($mdate);
		$rssyear += 1900;
		if (length($rsssec) < 2) { $rsssec = '0' . $rsssec; }
		if (length($rssmin) < 2) { $rssmin = '0' . $rssmin; }
		if (length($rsshour) < 2) { $rsshour = '0' . $rsshour; }
		if (length($rssday) < 2) { $rssday = '0' . $rssday; }
		$rssmonth++;
		if (length($rssmonth) < 2) { $rssmonth = '0' . $rssmonth; }
		$rsstimestring = $rssyear . '-' . $rssmonth . '-' . $rssday . 'T' . $rsshour . ':' . $rssmin . ':' . $rsssec . $RSS_Timeoffset;

		$YaBB_RSS .= qq~
<item>
<title>$msub</title>
<link>$scripturl\?num=$tnum\/$postposition[$i]\#$postposition[$i]</link>
<dc:date>$rsstimestring</dc:date>
<dc:creator>$mname</dc:creator>
<dc:subject>$boardname{$board}</dc:subject>
<description>$message</description>
</item>
~;
		++$counter; # Why here?
	} # end item loop
$YaBB_RSS .= qq~
</channel>
</rss>
~;
print $YaBB_RSS;
exit;
}

### Strip weird characters from input string
sub StripChars {
	$ch_32 = chr(32);
	$ch_160 = chr(160);
	$_[0] =~ s/[$ch_32]+/ /g;
	$_[0] =~ s/[$ch_160]+/ /g;
	$_[0] =~ s/&/&amp;/g;
	$_[0] =~ s/&nbsp;/ /g;
#	$_[0] =~ s/<br>//g;
	$_[0] =~ s/[\s]{2}/ /g;
	$_[0] =~ s/"/&quot;/g;
	$_[0] =~ s/</&lt;/g;
	$_[0] =~ s/>/&gt;/g;
#	$_[0] =~ s/#/&#35;/g;
#	$_[0] =~ s/$/&#36;/g;
#	$_[0] =~ s/%/&#37;/g;
#	$_[0] =~ s/@/&#64;/g;
#	$_[0] =~ s/^/&#94;/g;
#	$_[0] =~ s/`/&#96;/g;
#	$_[0] =~ s/}/&#125;/g;
#	$_[0] =~ s/~/&#126;/g;
#	$_[0] =~ s//&#150;/g;
#	$_[0] =~ s//&#151;/g;
	$_[0] =~ s//&#161;/g;
	$_[0] =~ s//&#162;/g;
	$_[0] =~ s//&#163;/g;
	$_[0] =~ s//&#8364;/g;
	$_[0] =~ s//&#164;/g;
	$_[0] =~ s//&#165;/g;
#	$_[0] =~ s//&#166;/g;
	$_[0] =~ s//&#167;/g;
	$_[0] =~ s//&#168;/g;
	$_[0] =~ s//&#169;/g;
	$_[0] =~ s//&#170;/g;
	$_[0] =~ s//&#171;/g;
	$_[0] =~ s//&#172;/g;
#	$_[0] =~ s/  /&#173;/g;
	$_[0] =~ s//&#174;/g;
	$_[0] =~ s//&#175;/g;
	$_[0] =~ s//&#176;/g;
	$_[0] =~ s//&#177;/g;
	$_[0] =~ s//&#178;/g;
	$_[0] =~ s//&#179;/g;
	$_[0] =~ s//&#180;/g;
	$_[0] =~ s//&#181;/g;
	$_[0] =~ s//&#182;/g;
	$_[0] =~ s//&#183;/g;
	$_[0] =~ s//&#184;/g;
	$_[0] =~ s//&#185;/g;
	$_[0] =~ s//&#186;/g;
	$_[0] =~ s//&#187;/g;
	$_[0] =~ s//&#188;/g;
	$_[0] =~ s//&#189;/g;
	$_[0] =~ s//&#190;/g;
	$_[0] =~ s//&#191;/g;
	$_[0] =~ s//&#192;/g;
	$_[0] =~ s//&#193;/g;
	$_[0] =~ s//&#194;/g;
	$_[0] =~ s//&#195;/g;
	$_[0] =~ s//&#196;/g;
	$_[0] =~ s//&#197;/g;
	$_[0] =~ s//&#198;/g;
	$_[0] =~ s//&#199;/g;
	$_[0] =~ s//&#200;/g;
	$_[0] =~ s//&#201;/g;
	$_[0] =~ s//&#202;/g;
	$_[0] =~ s//&#203;/g;
	$_[0] =~ s//&#204;/g;
	$_[0] =~ s//&#205;/g;
	$_[0] =~ s//&#206;/g;
	$_[0] =~ s//&#207;/g;
	$_[0] =~ s//&#208;/g;
	$_[0] =~ s//&#209;/g;
	$_[0] =~ s//&#210;/g;
	$_[0] =~ s//&#211;/g;
	$_[0] =~ s//&#212;/g;
	$_[0] =~ s//&#213;/g;
	$_[0] =~ s//&#214;/g;
	$_[0] =~ s//&#215;/g;
	$_[0] =~ s//&#216;/g;
	$_[0] =~ s//&#217;/g;
	$_[0] =~ s//&#218;/g;
	$_[0] =~ s//&#219;/g;
	$_[0] =~ s//&#220;/g;
	$_[0] =~ s//&#221;/g;
	$_[0] =~ s//&#222;/g;
	$_[0] =~ s//&#223;/g;
	$_[0] =~ s//&#224;/g;
	$_[0] =~ s//&#225;/g;
	$_[0] =~ s//&#226;/g;
	$_[0] =~ s//&#227;/g;
	$_[0] =~ s//&#228;/g;
	$_[0] =~ s//&#229;/g;
	$_[0] =~ s//&#230;/g;
	$_[0] =~ s//&#231;/g;
	$_[0] =~ s//&#232;/g;
	$_[0] =~ s//&#233;/g;
	$_[0] =~ s//&#234;/g;
	$_[0] =~ s//&#235;/g;
	$_[0] =~ s//&#236;/g;
	$_[0] =~ s//&#237;/g;
	$_[0] =~ s//&#238;/g;
	$_[0] =~ s//&#239;/g;
	$_[0] =~ s//&#240;/g;
	$_[0] =~ s//&#241;/g;
	$_[0] =~ s//&#242;/g;
	$_[0] =~ s//&#243;/g;
	$_[0] =~ s//&#244;/g;
	$_[0] =~ s//&#245;/g;
	$_[0] =~ s//&#246;/g;
	$_[0] =~ s//&#247;/g;
	$_[0] =~ s//&#248;/g;
	$_[0] =~ s//&#249;/g;
	$_[0] =~ s//&#250;/g;
	$_[0] =~ s//&#251;/g;
	$_[0] =~ s//&#252;/g;
	$_[0] =~ s//&#253;/g;
	$_[0] =~ s//&#254;/g;
	$_[0] =~ s//&#255;/g;
## new chars
	$_[0] =~ s//&#8216;/g;
	$_[0] =~ s//&#8217;/g;
	$_[0] =~ s//&#8230;/g;
	$_[0] =~ s//&#8240;/g;
}

sub RSS_Manage {

	&LoadLanguage("RSS_Feed");
	%rsscat;
	my %rsscatchecked;
	require "$vardir/rssfeed.txt";
	require "$boardsdir/forum.master";

### Set checks for each Category and Board, determined by rssfeed.txt ### 
	foreach $curcat(@categoryorder) {
		if( $rsscat{"$curcat"} eq 'rss' ) {
			$rsscatchecked{"$curcat"} = ' checked';
		}
		$boardlist = $cat{$curcat};
		(@bdlist) = split(/\,/, $boardlist);
		foreach $curboard (@bdlist) {
			if( $rssboard{"$curboard"} eq 'rss' ) {
				$rssboardchecked{"$curboard"} = ' checked';
			}
		}
	}

### Start building page, global RSS settings first, then category check boxs
	$yymain .= qq~
 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg">
		 <img src="$imagesdir/preferences.gif" alt="" border="0" /><b>$RSStxt{'07'}</b>
	   </td>
     </tr>
     <tr align="center" valign="middle">
       <td align="left" class="catbg"><span class="small">$modtxt{'1'} $RSStxt{'11'}</span>
	   </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2"><br />
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'01'}
		 </div>
		 <div class="setting_cell2">
			<input type="text" name="RSS_Display" size="3" value="$RSS_Display" />
		 </div>
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'02'}
		 </div>
		 <div class="setting_cell2">
			<input type="text" name="RSS_Description" size="35" value="$RSS_Description" />
		 </div>
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'03'}
		 </div>
		 <div class="setting_cell2">
			<input type="text" name="RSS_Timeoffset" size="7" value="$RSS_Timeoffset" />
		 </div>
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'04'}
		 </div>
		 <div class="setting_cell2">
			<input type="text" name="RSS_Cutoff" size="5" value="$RSS_Cutoff" />
		 </div>
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'05'}
		 </div>
		 <div class="setting_cell2">
			<input type="text" name="RSS_Image" size="35" value="$RSS_Image" /> <br /><br />
		 </div>
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'10'}
		 </div>
~;

	foreach $curcat(@categoryorder) {
		($catname, $catperms) = split(/\|/, $catinfo{"$curcat"});
		$yymain .= qq~
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'09'} $catname ($curcat)
		 </div>
		 <div class="setting_cell2">
			<input type="checkbox" name="rsscat{$curcat}" value="1"$rsscatchecked{$curcat} />
		 </div>
		~;
		$boardlist = $cat{$curcat};
		(@bdlist) = split(/\,/, $boardlist);
		foreach $curboard (@bdlist) {
			($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			$yymain .= qq~
	   	 <br />
		 <div class="setting_cell">
			$RSStxt{'08'} $boardname{$curboard} ($curboard)
		 </div>
		 <div class="setting_cell2">
			<input type="checkbox" name="rssboard{$curboard}" value="1"$rssboardchecked{$curboard} />
		 </div>
			~;
		}	
	}
	$yymain .= qq~
		 <br /><br />
	   </td>
     </tr>
   </table>
 </div>

<br />
~;
}

sub RSS_Manage2 {
	$RSS_Display = $FORM{'RSS_Display'} || "5";
	$RSS_Description = $FORM{'RSS_Description'} || "RSS Feed Description Here";
	$RSS_Timeoffset = $FORM{'RSS_Timeoffset'} || "+00:00";
	$RSS_Cutoff = $FORM{'RSS_Cutoff'} || "150";
	$RSS_Image = $FORM{'RSS_Image'} || "$smiliesurl/smiley.gif";

	my $filler = q~										      ~;
	my $setfile = << "EOF";
###############################################################################
# rssfeed.txt - Settings for RSS Feed 1.0 beta 1	       		      #
###############################################################################

\$RSS_Display = $RSS_Display;			# Number of recent Posts to display in RSS Feed
\$RSS_Description = "$RSS_Description";	# Description of RSS Feed Content
\$RSS_Timeoffset = "$RSS_Timeoffset";	# Enter Server time offset from GMT in hours (examples: +05:00 or -10:00 )
\$RSS_Cutoff = $RSS_Cutoff;			# Number of characters of each post to show in RSS content description, default = 150
\$RSS_Image = "$RSS_Image";			# URL of image to be used as logo on RSS Feed, default is smiley.
1;
EOF

#### Set RSS Cats
	my %rsscat;
	require "$boardsdir/forum.master";
	foreach $curcat(@categoryorder) {
		chomp $curcat;
		if( $FORM{"rsscat{$curcat}"} ) {$rsscat{"$curcat"} = 'rss'; }
		else { $rsscat{$curcat} = 'norss'; }
		$setfile .= qq~\$rsscat\{"$curcat"\} = "$rsscat{$curcat}";\n~;
		$boardlist = $cat{$curcat};
		(@bdlist) = split(/\,/, $boardlist);
		foreach $curboard (@bdlist) {
			if( $FORM{"rssboard{$curboard}"} ) {$rssboard{"$curboard"} = 'rss'; }
			else { $rssboard{$curboard} = 'norss'; }
			$setfile .= qq~\$rssboard\{"$curboard"\} = "$rssboard{$curboard}";\n~;
		}
	}
	$setfile .= qq~1;\n~;
#### end RSS Cats

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$vardir/rssfeed.txt");
	print FILE $setfile;
	fclose(FILE);
}

1;